#!/bin/sh

echo 2 > /proc/sys/vm/overcommit_memory
echo 100 > /proc/sys/vm/overcommit_ratio

echo "Start firmware upgrading" > /dev/console
start_lock=0;
data_file=/tmp/dm_tmp_file

#some validation
if [ -f "./fmw_board_type" ]; then
    cur_board=`factory board | sed y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/ | sed s/-//g | grep -o ^[A-Z]*[0-9]*`
    case "$cur_board"  in
    "RG2404")  board_type="RG24";;
    "RG4404")  board_type="RG24";;
    "RG4414")  board_type="RG24";;
    "RG2402")  board_type="RG24";;
    "RG4402")  board_type="RG24";;
    "RG4412")  board_type="RG24";;
    "TAU1")    board_type="TAU1";;
    "TAU2")    board_type="TAU2";;
    "VP12P")   board_type="VP12P";start_lock=1;;
    "VP12")    board_type="VP12";start_lock=1;;
    esac
echo "Board Type [$board_type]" > /dev/console

    if [ -z "$board_type" ]; then
        echo "UPGRADE FAIL: wrong factory settings"
        exit 1;
    fi

    fmw_type=`cat ./fmw_board_type`
    if [ "$fmw_type" != "$board_type" ]; then
        echo "UPGRADE FAIL: firmware for $fmw_type but board is $cur_board"
        exit 1;
    fi
fi

if [ $start_lock = 1 ];
    then
    ps|grep driver_manager > $data_file
    data2=$(sed -n 's/run_daemon//p' $data_file);
    count=$(echo ${#data2})
    if [ $count = 0 ];
        then
            data2=$(sed -e  '2,$d' $data_file);
        else
            data2=$(sed -e  '1d;3,$d' $data_file);
    fi
    pid=$(echo $data2|sed -e 's/root.*//;s///')
    kill -s 17 $pid
fi

md5_cur=`busybox md5sum ./linux.bin | cut -d' ' -f 1`
md5_img=`cat md5_linux`
if [ "$md5_cur" != "$md5_img" ]; then
    echo "UPGRADE FAIL: Incorrect CRC";
    exit 1;
fi

killall igmpproxy udpxy

if [ -f /tmp/fw/utils/upgrade-bin ]; then
    FW_PATH="/tmp/fw"
else
    if [ -f /tmp/auto_fw_upgrade/utils/upgrade-bin ]; then
        FW_PATH="/tmp/auto_fw_upgrade"
    else
        if [ -f /tmp/dhcp_fw_upgrade/utils/upgrade-bin ]; then
            FW_PATH="/tmp/dhcp_fw_upgrade"
        else
            FW_PATH="/tmp/fw_tr069"
        fi
    fi
fi


chmod 777 $FW_PATH/utils/stop_voip
$FW_PATH/utils/stop_voip
chmod 777 $FW_PATH/upgrade-bin

echo "Stopping VoIP service" > /dev/console
kill `ps| grep "/bin/run_daemon.sh voip"|head -n 1|cut -d' ' -f 2`
echo "" > /tmp/restart_voip

sleep 3
sleep 3
killall voip
sleep 3

cur_major=$(cat /version|cut -d'.' -f 1)
cur_minor=$(cat /version|cut -d'.' -f 2)

#Workaround for 1.5.0
if [ $cur_major -eq 1 ]; then
    if [ $cur_minor -eq 5 ]; then
        mv /bin/factory /bin/_factory
    fi
fi

echo "Upgrade firmware started"
echo "Upgrade firmware started" > /dev/console
$FW_PATH/utils/upgrade-bin ./linux.bin &> /dev/console
RETVAL=$?

if [ "$RETVAL" != "0" ]; then
    if [ "$RETVAL" = "254" ]; then
        echo "UPGRADE FAIL: upgrade process is already in progress" > /dev/console;
        echo "UPGRADE FAIL: upgrade process is already in progress";
        exit 2;
    fi
    echo "UPGRADE FAIL: Error at read/write operation" > /dev/console;
    echo "UPGRADE FAIL: Error at read/write operation";
    exit 1;
fi

if [ $cur_major -eq 1 ]; then
    if [ $cur_minor -eq 5 ]; then
        mv /bin/_factory /bin/factory
    fi
fi



if [ -e "$FW_PATH/defaults" ];then
    echo "UPGRADE : update def.yaml" > /dev/console;
    echo "UPGRADE : update def.yaml";
    cd $FW_PATH
    cat /proc/mtd | grep "mtd2" > /dev/null
    if [ $? == 0 ]; then
        tar -c defaults | gzip | $FW_PATH/utils/save_util default
    else
        tar -c defaults | gzip | $FW_PATH/utils/save_def_yaml_old
    fi
#    tar -c defaults | gzip | $FW_PATH/utils/save_util default
    cd -
fi


bvesion="0"
if [ -f "/bin/boot_version" ];then
res=`/bin/boot_version`
  if [ "$res" != "" ];then
        bversion="1"
  fi

fi
if [ "$bversion" == "1" ];then
    bank="`cat /proc/bootbank`"
    if [ "$bank" == "1" ];then
        md5sum set linux2 `cat $FW_PATH/md5_linux`
    else
        md5sum set linux1 `cat $FW_PATH/md5_linux`
    fi
else
        echo "Old loader"
fi



echo "UPGRADE SUCCESSFULL" > /dev/console
echo "UPGRADE SUCCESSFULL"
exit 0;
